var app = app || {};
app.windowScale = 1 / 4;

function newStage(){
    var stage = new Kinetic.Stage({
        container:  'canvas',
        width:      $('#canvas').width(),
        height:     $('#canvas').height()
    });
    
    stage.setPosition({
        x: stage.getWidth() / 2,
        y: stage.getHeight() / 2
    });
    
    return stage;
};

function addNodes(){
    logText('Updating canvas layers...');
        
    for (server in app.WatcherView.model.attributes){
        logText('Updating layer: ' + server);
        app.WatcherView.serverLayers[server] = new Kinetic.Layer();
        app.WatcherView.serverLayers[server]._id = server;
        //app.WatcherView.serverLayers[server].setZIndex(0);
        
        var image = new Kinetic.Image({
            x:          Math.floor((Math.random() * app.WatcherView.stage.getWidth()) - (app.WatcherView.stage.getWidth() / 2)),
            y:          Math.floor((Math.random() * app.WatcherView.stage.getHeight()) - (app.WatcherView.stage.getHeight() / 2)),
            image:      databaseIcons,
            width:      256,
            height:     256,
            scale:      app.windowScale
        });
        
        image.setOffset({
            x:          image.getWidth() / 2,
            y:          image.getHeight() / 2
        });
        
        
        // MASTER positioning and scale
        if(app.WatcherView.model.attributes[server].attr.hasOwnProperty('master')){
            image.setPosition(0, 0);
            image.setScale(app.windowScale * 1.5);
            //app.WatcherView.serverLayers[server].setZIndex(0);
        }
        
        app.WatcherView.serverLayers[server].add(image);
        app.WatcherView.stage.add(app.WatcherView.serverLayers[server]);
    }
};

function addLines(){
    for (server in app.WatcherView.model.attributes){
        if(app.WatcherView.model.attributes[server].attr.hasOwnProperty('P4TARGET')){
            var line = new Kinetic.Line({
                strokeRGB: {
                    r: 200,
                    g: 200,
                    b: 200},
                points: [app.WatcherView.serverLayers[server].children[0].getX(), app.WatcherView.serverLayers[server].children[0].getY(), 0, 0]
            });
            
            app.WatcherView.serverLayers[server].add(line);
            line.setZIndex(0);
            app.WatcherView.serverLayers[server].moveToBottom();
        }
    }
}

function makeRelTree(){
    for (server in app.WatcherView.model.attributes){
        if(app.WatcherView.model.attributes[server].attr.hasOwnProperty('P4TARGET')){
            
        }
    }
}